Program Example; {88/05/20 - by Mike Babulic}

{$T APPLAPP?}       { Set application ID                    }
{$B+}

{$U MikeApp}

(*TURBO*)
{$U-}               { Turn off auto link to runtime units   }
{$R Example.rsrc}
  USES PasInOut,Memtypes,QuickDraw,OSIntf,ToolIntf,PackIntf,MikeApp;
(**)

(*TML
{$L Example.rsrc}
  USES MacIntf,MikeApp;
*)

{---------------------------- Text Window -----------------------------}

VAR
          
      MyApp : TApp;
      
        MyWindow : WindowPtr;
          WindowArea: Rect;

          MyText   : TEHandle;
            ViewArea,DestArea : Rect;

PROCEDURE SetUpWindow;
  VAR title : str255;
  BEGIN
    SetAppPort(WindowPtr(TAppDefaults^^.theWindow));
    TextFont(applFont);
    TextSize(12);
    TextFace([]);
    TextMOde(1);
    {SetUpTE}
      WITH appPort^.portRect DO
        SetRect(ViewArea, left+4,top+4,right-1,bottom-1);
      DestArea := ViewArea;
      MyText := TENew(DestArea,ViewArea);
  END;{SetUpWindow}

PROCEDURE MyOpen;
  BEGIN
    SysBeep(1);
    ShowWindow(MyWindow);
    SelectWindow(MyWindow);
    InvalRect(MyWindow^.portRect);
  END;

PROCEDURE MyDrawText;
  VAR
    str0,str1,str2 : str255;
  BEGIN
    str0 := chr(13);
    ForeColor(blackColor);
    str1 := 'This is Text.';
    str2 := 'Blah Blah Blah';
    TESetSelect (0,0, MyText);
    TESetText(pointer(ord(@str1)+1),length(str1), MyText);
      TEInsert(pointer(ord(@str0)+1),length(str0), MyText);
      TEInsert(pointer(ord(@str2)+1),length(str2), MyText);
  END;

PROCEDURE MyPeriodicActivity;
  BEGIN
    TEIdle(MyText);
  END;

PROCEDURE MyActivate(updateWindow:WindowPtr);
  BEGIN
    TEActivate(MyText);
       {we only want to TEIdle when this window is active}
    appMethodsH^^.doPeriodicActivity := @MyPeriodicActivity;
  END;

PROCEDURE MyDeActivate(updateWindow:WindowPtr);
  BEGIN
       {Turn off TEIdle, we only want to TEIdle when this window is active}
    appMethodsH^^.doPeriodicActivity := @NoProc;
   TEDeactivate(MyText);
  END;

PROCEDURE MyUpdate(updateWindow:WindowPtr);
  BEGIN
    PenNormal;
    EraseRect(updateWindow^.portRect);
    MoveHHi(handle(MyText));
    HLock(handle(MyText));
    MyDrawText;
    TEUpdate(updateWindow^.portRect, MyText);
  END;

PROCEDURE InitTextClass;
  BEGIN
    SetUpWIndow;
    MyWindow := DefaultPort;

    WITH appMethodsH^^ DO BEGIN
     
        onActivate   := @MyActivate;
        onDeactivate := @MyDeactivate;
          
          doUpdate     := @MyUpdate;
          doPeriodicActivity := @MyPeriodicActivity;
        
    END;
  END;

{---------------------------- Bullseye Window -----------------------------}

VAR
      MBullsEye : MApp;
      
        BWindow : WindowPtr;
          BWindows : Integer;    {count of bullseye windows}
        
        Bullseyes : integer;

PROCEDURE OffsetWindow(w:WindowPtr; num:integer);
  {Offset location of a new window}
  CONST
    MenuBar  = 20;
    TitleBar = 20;
    dx =  10;   {offset from prev window}
    dy =  20;
  VAR
    width,height : integer;   {of window in pixels}
    xX,xY        : integer;   {extra screen width & height}
    maxX,maxY    : integer;   {max horz & vert # windows}
    x,y          : integer;   {new pos of window in global coords}
  BEGIN
    WITH w^.portrect DO BEGIN {find size of window}
      width  := right - left;
      height := bottom - top + TitleBar;
    END;
    WITH Screen DO BEGIN      {how much bigger is the screen?}
      xX := right - left - width;
      xY := bottom - top - height;
    END;
    maxX := (xX DIV dx) + 1;
    maxY := (xY DIV dy) + 1;
    x := (num mod maxX) * dx;
    y := ((num-1) mod maxy) * dy + TitleBar + MenuBar;
    MoveWindow(w,x,y,TRUE);
  END;

PROCEDURE BOpen;
  VAR Temp : TApp;
      Name : Str255;
      pt,old   : Point;
  BEGIN
    IF BWindows>=10 THEN
      SysBeep(1)
    ELSE BEGIN
      BWindows := succ(BWindows);
      appPort := GetNewWindow(DefaultWindowId,NIL,Pointer(-1));
      Temp := GetNewTapp(SizeOf(AppData),appPort,MBullseye);
      Bullseyes := succ(Bullseyes); {Title Window}
        NumToString(Bullseyes,Name);
        SetWTitle(appPort,Name);
     {Shift window over a tad}
        OffsetWindow(appPort,Bullseyes);
      ShowWindow(appPort);
      InvalRect(appPort^.portRect);
    END;
  END;

PROCEDURE BClosing;
  BEGIN
    BWindows := pred(BWindows);
    CloseWindow(appPort);
    DisposeTApp(appDataH);
  END;
 

PROCEDURE DrawBullseye;
  CONST
     Rings = 4;
  VAR
     r,s : rect;
     d,i : integer;
  BEGIN
    r := thePort^.portRect;
    with r do begin
      if right > bottom then begin
        left := right - bottom;
        i := -left DIV 2;
        left := left + i;
        right := right + i;
       end
      else begin
        top := bottom - right;
        i := -top DIV 2;
        top := top + i;
        bottom := bottom + i;
      end;
      d := (right - left) DIV (Rings*2);
    end;
    InsetRect(r,4,4);
    s := r;
    PenNormal;
    PenMode(srcXor+patXor);
    BackColor(whiteColor);
    for i := 1 to Rings do begin
      if not odd(i) then begin
        ForeColor(MagentaColor);
        FillOval(r,black);
       end
      else begin
        ForeColor(CyanColor);
        FillOval(r,ltGray);
      end;
      InsetRect(r,d,d);
    end;
    PenNormal;
    FrameOval(s);
  END;

PROCEDURE BUpdate(updateWindow:WindowPtr);
  BEGIN
    EraseRect(updateWindow^.portRect);
    DrawBullseye;
  END;

PROCEDURE BPeriodicActivity;
  BEGIN
  END;

PROCEDURE BDrawGrowBox(updateWindow:WindowPtr);
  BEGIN
    PenNormal;
    PenSize(0,0);
    TAppOnDrawGrowBox(updateWindow);
  END;

PROCEDURE InitBullsEye;
  BEGIN
    MBullsEye := CloneMethods(TAppDefaults^^.methods);
    Bullseyes := 0;
    BWindows  := 0;
    WITH MBullsEye^^ DO BEGIN
      doUpdate := @BUpdate;
      onDrawGrowBox := @BDrawGrowBox;
        doNew    := @BOpen;
          whenClosing := @BClosing;
          doPeriodicActivity := @BPeriodicActivity;
    END;
  END;

{------------------------------------------------------------------------------}

PROCEDURE MyInit;
  BEGIN
    InitBullseye;
    InitTextClass;
  END;


  
{------------------------------------------------------------------------------}

PROCEDURE InitMethods;
  BEGIN WITH AppMethodsH^^ DO BEGIN
    whenInit := @myInit;
      doNew    := @BOpen;
      doOpen   := @MyOpen;
      BPeriodicActivity
  END  END;

BEGIN
  MikeApp(@InitMethods); 
END.