PROGRAM NaD;
{--------------------------------------------------------------------}
{               This is a demonstration program for                  }
{            DataBase PowerTools for LightSpeed Pascal.              }
{                                                                    }
{      1985, 1986, 1987, Michael Noel, All rights reserved.         }
{--------------------------------------------------------------------}

	USES
		isam, speechintf;

	CONST
		AppleMenu = 256;
		FileMenu = 257;
		EditMenu = 258;
		SpeakMenu = 259;

		INQDLG = 257;
		ADDDLG = 267;
		ALBLDLG = 280;
		AISMDLG = 290;

	TYPE
		lblrec = RECORD
				NumLink : integer;
				kind : integer;
				person : PACKED ARRAY[1..40] OF char;
				company : PACKED ARRAY[1..40] OF char;
				addr : PACKED ARRAY[1..40] OF char;
				citystate : PACKED ARRAY[1..40] OF char;
				phone : PACKED ARRAY[1..40] OF char;
			END;

		edrec = RECORD
				person : str255;
				company : str255;
				addr : str255;
				citystate : str255;
				phone : str255;
			END;

	VAR
		prt, mdm : text;

		pset, mset : boolean;
		fileisopen : boolean;
		finished : boolean;
		INQshow : boolean;
		ADDshow : boolean;

		TheWatch : CursHandle;
		TheIBeam : CursHandle;
		FMhandle : MenuHandle;
		SMhandle : MenuHandle;
		INQptr : DialogPtr;
		ADDptr : DialogPtr;

		SWCrect : Rect;

		etext : str255;
		findit : str255;
		fname : str255;
		foundit : str255;
		vtext : str255;

		drefnum : integer;
		errcode : integer;
		kn, en : integer;
		maxnumlink : integer;

		recno : longint;
		oldrecno : longint;

		DataRec : lblrec;
		EditRec : edrec;
		key : keydeftype;

		SErr, SErr2 : SpeechErr;
		Phonetics : Handle;
		theSpeech : SpeechHandle;
		SW : ARRAY[0..5] OF integer;


	PROCEDURE SayIt (mess : str255);
		VAR
			numchars : integer;
			TextInPtr : ^char;
	BEGIN
		numchars := length(mess);
		TextInPtr := pointer(ord(@mess) + 1);
		IF (SErr = 0) AND (numchars > 0) THEN
			BEGIN
				SetCursor(TheWatch^^);
				Phonetics := NewHandle(0);
				SErr2 := Reader(theSpeech, Pointer(TextInPtr), numChars, Phonetics);
				SErr2 := MacinTalk(theSpeech, Phonetics);
				DisposHandle(Phonetics);
				SetCursor(arrow);
			END;
		SW[0] := 0;
	END;


	PROCEDURE AboutNaD;
		VAR
			ItemHit : Integer;
			thedialog : DialogPtr;
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;
			nadmsg : str255;
	BEGIN
		thedialog := GetNewDialog(ALBLDLG, NIL, Pointer(-1));
		ShowWindow(thedialog);
		ModalDialog(NIL, ItemHit);
		DisposDialog(thedialog);
	END;


	PROCEDURE msg (mess : str255);
		VAR
			ItemHit : Integer;
			thedialog : DialogPtr;
	BEGIN
		ParamText(fname, mess, '', '');
		thedialog := GetNewDialog(AISMDLG, NIL, Pointer(-1));
		ShowWindow(thedialog);
		ModalDialog(NIL, ItemHit);
		DisposDialog(thedialog);
	END;


	PROCEDURE AboutISAM;
	BEGIN
		SetDAFont(1);
		msg(vtext);
		SetDAFont(0);
	END;


	PROCEDURE GetRec;
		VAR
			err : Oserr;
			i : longint;
	BEGIN
		IF oldrecno >= 0 THEN
			BEGIN
				errcode := ISAMreleasehold(drefnum, oldrecno);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
					END;
				oldrecno := -1;
			END;
		IF recno >= 0 THEN
			BEGIN
				i := SizeOf(DataRec);
				err := SetFPos(drefnum, 1, (recno) * i);
				err := FSRead(drefnum, i, @DataRec);
				errcode := ISAMholdforupdate(drefnum, @DataRec, recno);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
					END
				ELSE
					oldrecno := recno;
			END
		ELSE
			BEGIN
				FOR i := 1 TO 40 DO
					BEGIN
						DataRec.person[i] := ' ';
						DataRec.company[i] := ' ';
						DataRec.addr[i] := ' ';
						DataRec.citystate[i] := ' ';
						DataRec.phone[i] := ' ';
					END;
			END;
	END;


	PROCEDURE PutRec;
		VAR
			err : Oserr;
			i : longint;
	BEGIN
		IF recno >= 0 THEN
			BEGIN
				i := SizeOf(DataRec);
				err := SetFPos(drefnum, 1, (recno) * i);
				err := FSWrite(drefnum, i, @DataRec);
			END;
	END;


	PROCEDURE ToEditRec;
		VAR
			i : integer;
	BEGIN
		EditRec.person := ' ';
		EditRec.company := ' ';
		EditRec.addr := ' ';
		EditRec.citystate := ' ';
		EditRec.phone := ' ';
		WITH DataRec DO
			BEGIN
				FOR i := 1 TO 40 DO
					BEGIN
						EditRec.person[i] := person[i];
						EditRec.company[i] := company[i];
						EditRec.addr[i] := addr[i];
						EditRec.citystate[i] := citystate[i];
						EditRec.phone[i] := phone[i];
						IF (person[i] <> ' ') AND (person[i] <> chr(0)) THEN
							EditRec.person[0] := chr(i);
						IF (company[i] <> ' ') AND (company[i] <> chr(0)) THEN
							EditRec.company[0] := chr(i);
						IF (addr[i] <> ' ') AND (addr[i] <> chr(0)) THEN
							EditRec.addr[0] := chr(i);
						IF (citystate[i] <> ' ') AND (citystate[i] <> chr(0)) THEN
							EditRec.citystate[0] := chr(i);
						IF (phone[i] <> ' ') AND (phone[i] <> chr(0)) THEN
							EditRec.phone[0] := chr(i);
					END;
				SW[0] := 1;
			END;
	END;


	PROCEDURE ToDataRec;
		VAR
			i : integer;
	BEGIN
		WITH EditRec DO
			BEGIN
				FOR i := 1 TO 40 DO
					BEGIN
						IF i <= length(person) THEN
							DataRec.person[i] := person[i]
						ELSE
							DataRec.person[i] := ' ';
						IF i <= length(company) THEN
							DataRec.company[i] := company[i]
						ELSE
							DataRec.company[i] := ' ';
						IF i <= length(addr) THEN
							DataRec.addr[i] := addr[i]
						ELSE
							DataRec.addr[i] := ' ';
						IF i <= length(citystate) THEN
							DataRec.citystate[i] := citystate[i]
						ELSE
							DataRec.citystate[i] := ' ';
						IF i <= length(phone) THEN
							DataRec.phone[i] := phone[i]
						ELSE
							DataRec.phone[i] := ' ';
					END;
			END;
	END;


	FUNCTION StringAll (thechar : char;
									len : integer) : str255;
		VAR
			lclstr : STRING;
			i : integer;
	BEGIN
		lclstr[0] := chr(len);
		FOR i := 1 TO len DO
			lclstr[i] := thechar;
		StringAll := lclstr;
	END;


	FUNCTION StringUPR (thestr : str255) : str255;
	BEGIN
		UprString(thestr, FALSE);
		StringUPR := thestr;
	END;


	PROCEDURE SetUpINQ;
		VAR
			thedialog : DialogPtr;
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;
	BEGIN
		thedialog := INQptr;
		ParamText(fname, '', '', '');
		GetDItem(thedialog, 2, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.person);
		GetDItem(thedialog, 4, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.company);
		GetDItem(thedialog, 6, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.addr);
		GetDItem(thedialog, 8, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.citystate);
		GetDItem(thedialog, 10, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.phone);
		GetDItem(thedialog, 3, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 0);
		GetDItem(thedialog, 5, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 0);
		GetDItem(thedialog, 7, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 0);
		GetDItem(thedialog, 9, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 0);
		GetDItem(thedialog, 11, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 0);
		SelIText(thedialog, (en * 2), 0, 999);
		GetDItem(thedialog, (kn * 2) + 1, ItemType, ItemHandle, ItemBox);
		SetCtlValue(ControlHandle(ItemHandle), 1);
		ShowWindow(INQptr);
		SetPort(INQptr);
		INQshow := TRUE;
	END;


	PROCEDURE SetUpADD;
		VAR
			thedialog : DialogPtr;
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;
	BEGIN
		thedialog := ADDptr;
		ParamText(fname, '', '', '');
		GetDItem(thedialog, 2, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.person);
		GetDItem(thedialog, 3, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.company);
		GetDItem(thedialog, 4, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.addr);
		GetDItem(thedialog, 5, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.citystate);
		GetDItem(thedialog, 6, ItemType, ItemHandle, ItemBox);
		SetIText(ItemHandle, EditRec.phone);
		SelIText(thedialog, (en + 1), 0, 999);
		ShowWindow(ADDptr);
		SetPort(ADDptr);
		ADDshow := TRUE;
	END;


	PROCEDURE closefile;
		VAR
			err : oserr;
	BEGIN
		IF fileisopen THEN
			BEGIN
				fileisopen := FALSE;
				SetCursor(TheWatch^^);
				recno := 0;
				GetRec;
				DataRec.numlink := maxnumlink;
				PutRec;
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
					END;
				EnableItem(FMhandle, 0);
				DrawMenuBar;
				HideWindow(INQptr);
				INQshow := FALSE;
				fname := '';
			END;
		SetCursor(arrow);
	END; {of procedure closefile}


	PROCEDURE doopen (VAR reply : SFReply);
		LABEL
			999;
		VAR
			err : oserr;
			fstats : filestattype;
			kstats : keystattype;
			key : keydeftype;
			keyid : integer;
			i : longint;
			ItemHit : Integer;
			thedialog : DialogPtr;
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;

		PROCEDURE CenterFname;
		BEGIN
			ParamText(fname, '', '', '');
			GetDItem(INQptr, 1, ItemType, ItemHandle, ItemBox);
			i := (ItemBox.right - ItemBox.left - StringWidth(fname)) DIV 2;
			IF i > 0 THEN
				BEGIN
					i := i DIV CharWidth(' ');
					fname := Concat(stringALL(' ', i), fname);
					ParamText(fname, '', '', '');
				END
			ELSE IF i < 0 THEN
				BEGIN
					i := pos(':', fname);
					IF i > 0 THEN
						BEGIN
							delete(fname, 1, i);
							insert('...', fname, 1);
							CenterFname;
						END;
				END;
		END; {of CenterFname}

	BEGIN
		IF fileisopen THEN
			closefile;
		SetCursor(TheWatch^^);
		err := FSOpen(reply.fName, reply.vRefNum, drefnum);
		IF err <> 0 THEN
			BEGIN
				msg('can not open that file');
				GOTO 999;
			END;
		errcode := ISAMopen(drefnum, isamOpOverRide);
		IF errcode <> isamOK THEN
			BEGIN
				ISAMerror(etext);
				msg(etext);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		errcode := ISAMextract(drefnum, fstats);
		IF errcode <> isamOK THEN
			BEGIN
				ISAMerror(etext);
				msg(etext);
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		IF (fstats.DataRecSize <> SizeOf(DataRec)) OR (fstats.NumIndices <> 6) THEN
			BEGIN
				msg('This ISAM file not for use in this program');
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		FOR i := 1 TO 6 DO
			BEGIN
				errcode := ISAMextractkey(drefnum, keyid, key, kstats);
				IF (errcode <> isamOK) THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				IF (keyid < 1) OR (keyid > 6) THEN
					BEGIN
						msg('This ISAM file not for use in this program');
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
			END;
		oldrecno := -1;
		recno := 0;
		GetRec;
		maxnumlink := DataRec.numlink;
		kn := 1;
		en := 1;
		errcode := ISAMkey(drefnum, kn, FWD);
		IF errcode <> isamOK THEN
			BEGIN
				ISAMerror(etext);
				msg(etext);
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		findit := '';
		errcode := ISAMfind(drefnum, findit, foundit, recno);
		IF ((errcode > isamOK) AND (errcode < isamWARN)) THEN
			BEGIN
				ISAMerror(etext);
				msg(etext);
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		errcode := ISAMnext(drefnum, recno, foundit);
		IF ((errcode > isamOK) AND (errcode < isamWARN)) THEN
			BEGIN
				ISAMerror(etext);
				msg(etext);
				errcode := ISAMclose(drefnum);
				err := FSClose(drefnum);
				GOTO 999;
			END;
		GetRec;
		ToEditRec;
		DisableItem(FMhandle, 0);
		DrawMenuBar;
		err := BuildPathName(reply.fName, reply.vRefNum, fname);
		SetUpINQ;
		CenterFname;
		fileisopen := TRUE;
999 :
	END; {of procedure doopen}


	PROCEDURE OLDFile;
		VAR
			loc : Point;
			ftitle : str255;
			typeList : SFTypeList;
			reply : SFReply;
	BEGIN
		loc.v := 80;
		loc.h := 100;
		ftitle := 'input file name';
		typeList[0] := 'NaDa';
		SFGetFile(loc, ftitle, NIL, 1, typeList, NIL, reply);
		IF reply.good THEN
			BEGIN
				SetCursor(TheWatch^^);
				reply.fName := StringUPR(reply.fName);
				doopen(reply);
			END;
		SetCursor(arrow);
	END; {of procedure OLDFile}


	PROCEDURE NEWFile;
		LABEL
			999;
		VAR
			loc : Point;
			ftitle, origname : str255;
			reply : SFReply;
			err : oserr;
			keyid : integer;
			key : keydeftype;
			workstr : str255;
	BEGIN
		loc.v := 80;
		loc.h := 100;
		ftitle := 'new NaD-file name';
		origname := '';
		SFPutFile(loc, ftitle, origname, NIL, reply);
		IF reply.good THEN
			BEGIN
				closefile;
				SetCursor(TheWatch^^);
				reply.fName := StringUPR(reply.fName);
				workstr := copy(reply.fName, length(reply.fName) - 3, 4);
				IF workstr = '.IDX' THEN
					delete(reply.fName, length(reply.fName) - 3, 4);
		{ create the data file }
				err := FSDelete(reply.fName, reply.vRefNum);
				err := Create(reply.fName, reply.vRefNum, '????', 'NaDa');
				err := FSOpen(reply.fName, reply.vRefNum, drefnum);
		{ create the index file }
				errcode := ISAMdefine(drefnum, SizeOf(DataRec), 2, 0);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				errcode := ISAMopen(drefnum, 0);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						err := FSClose(drefnum);
						GOTO 999;
					END;
		{ create 5 indexes, one for each edit field (sort of) }
				keyid := 1;		{ person then company }
				key.NumKeyParts := 2;
				key.Keys[1].BeginPos := 5;
				key.Keys[1].Length := 40;
				key.Keys[1].DefType := 0;
				key.Keys[2].BeginPos := 45;
				key.Keys[2].Length := 40;
				key.Keys[2].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				keyid := 2;		{ company then person }
				key.NumKeyParts := 2;
				key.Keys[1].BeginPos := 45;
				key.Keys[1].Length := 40;
				key.Keys[1].DefType := 0;
				key.Keys[2].BeginPos := 5;
				key.Keys[2].Length := 40;
				key.Keys[2].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				keyid := 3;		{ addr }
				key.NumKeyParts := 1;
				key.Keys[1].BeginPos := 85;
				key.Keys[1].Length := 40;
				key.Keys[1].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				keyid := 4;		{ citystate }
				key.NumKeyParts := 1;
				key.Keys[1].BeginPos := 125;
				key.Keys[1].Length := 40;
				key.Keys[1].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				keyid := 5;		{ phone }
				key.NumKeyParts := 1;
				key.Keys[1].BeginPos := 165;
				key.Keys[1].Length := 40;
				key.Keys[1].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
		{ now create a special index to keep track of NOTEs }
				keyid := 6;		{ note }
				key.NumKeyParts := 1;
				key.Keys[1].BeginPos := 1;
				key.Keys[1].Length := 6;
				key.Keys[1].DefType := 0;
				errcode := ISAMdefinekey(drefnum, keyid, key);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
		{ make ADD, UPDATE, DELETE bypass NOTE index }
				errcode := ISAMinvalidindex(drefnum, keyid);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
		{ allocate a data rec to hold some control info }
				errcode := ISAMallocdata(drefnum, recno);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						errcode := ISAMclose(drefnum);
						err := FSClose(drefnum);
						GOTO 999;
					END;
		{ initialize the control record }
				recno := 0;
				DataRec.NumLink := 0;
				DataRec.Kind := 0;
				BlockMove(@DataRec, @DataRec.Person, SizeOf(DataRec) - 4);
				PutRec;
		{ close the newly defined file }
				errcode := ISAMclose(drefnum);
				IF errcode <> isamOK THEN
					BEGIN
						ISAMerror(etext);
						msg(etext);
						err := FSClose(drefnum);
						GOTO 999;
					END;
				err := FSClose(drefnum);
		{ now go thru standard open process for new file }
				doopen(reply);
			END;
999 :	{come here for error}
		SetCursor(arrow);
	END; {of procedure NEWFile}


	PROCEDURE OffToIt (mode : integer;
									VAR fName : Str255);
	INLINE
		$204F, 	{movea.l  a7,a0		;  (a0) is a ptr to string }
		$A9F2;	{_Launch				; 4(a0) is mode }


	PROCEDURE DoXfr;
		VAR
			loc : Point;
			ftitle : str255;
			typeList : SFTypeList;
			reply : SFReply;
			err : oserr;
			aname : str255;
	BEGIN
		loc.v := 80;
		loc.h := 100;
		ftitle := 'transfer to?';
		typeList[0] := 'APPL';
		SFGetFile(loc, ftitle, NIL, 1, typeList, NIL, reply);
		IF reply.good THEN
			BEGIN
				err := BuildPathName(reply.fName, reply.vRefNum, aname);
				IF err = 0 THEN
					OffToIt(0, aname)
				ELSE
					msg('BuildPathName failed for that Application!!!');
			END;
	END; {of procedure DoXfr}


	PROCEDURE ProcessMenu_in (CodeWord : longint);
		VAR
			Menu_No : integer;
			Item_No : integer;
			NameHolder : Str255;
			dummy : oserr;
	BEGIN
		IF CodeWord <> 0 THEN
			BEGIN
				Menu_No := HiWord(CodeWord);
				Item_no := LoWord(CodeWord);
				HiliteMenu(0);
				CASE Menu_No OF
					AppleMenu : 
						BEGIN
							IF Item_No = 1 THEN
								AboutNaD
							ELSE IF Item_No = 2 THEN
								AboutISAM
							ELSE
								BEGIN
									GetItem(GetMHandle(AppleMenu), Item_No, NameHolder);
									dummy := OpenDeskAcc(NameHolder);
								END;
						END;
					FileMenu : 
						BEGIN
							CASE Item_No OF
								1 : 
									NEWFile;						{new}
								2 : 
									OLDFile;						{open}
								3 : 
									DoXfr;							{transfer}
								4 : 
									Finished := True;		   {quit}
								OTHERWISE
							END;
						END;
					EditMenu : 
						BEGIN
							IF NOT SystemEdit(Item_no - 1) THEN
								CASE Item_No OF
									1 : 
										BEGIN							{undo}
											dummy := PostEvent(KeyDown, 26);
										END;
									2 : 
										BEGIN
										END;				           {can't happen}
									3 : 
										BEGIN							{cut}
											dummy := PostEvent(KeyDown, 24);
										END;
									4 : 
										BEGIN							{copy}
											dummy := PostEvent(KeyDown, 3);
										END;
									5 : 
										BEGIN							{paste}
											dummy := PostEvent(KeyDown, 22);
										END;
									6 : 
										BEGIN						{clear}
											dummy := PostEvent(KeyDown, 2);
										END;
									OTHERWISE
								END;
						END;
					SpeakMenu : 
						BEGIN
							IF SW[Item_no] = 0 THEN
								BEGIN
									SW[Item_no] := 1;
									CheckItem(SMhandle, Item_no, TRUE);
								END
							ELSE
								BEGIN
									SW[Item_no] := 0;
									CheckItem(SMhandle, Item_no, FALSE);
								END;
						END;
					OTHERWISE
				END;{case of Menu_No}
			END; {the If codeword <> 0}
	END; {of ProcessMenu_in procedure}


	PROCEDURE DoLabel;
	BEGIN
		SetCursor(TheWatch^^);
		IF pset THEN
			BEGIN
				pset := FALSE;
				rewrite(prt, 'printer:');
			END;
		writeln(prt, EditRec.person);
		writeln(prt, EditRec.company);
		writeln(prt, EditRec.addr);
		writeln(prt, EditRec.citystate);
		writeln(prt);
		writeln(prt, EditRec.phone);
		writeln(prt);
		writeln(prt);
		writeln(prt);
		SetCursor(arrow);
	END;


	PROCEDURE DoDial;
		VAR
			tick : longint;
	BEGIN
		SetCursor(TheWatch^^);
		IF mset THEN
			BEGIN
				mset := FALSE;
				open(mdm, 'modem:');
			END;
		write(mdm, 'ATDT');
		write(mdm, EditRec.phone);
		writeln(mdm, ';');
		tick := 600 + TickCount;
		WHILE tick > TickCount DO
			; {hang here for 10 seconds}
		writeln(mdm, 'ATZ');
		SetCursor(arrow);
	END;


	PROCEDURE DoNote;
		VAR
			err : oserr;
			lenwtr : longint;
	BEGIN
		WITH EditRec DO
			BEGIN
				msg('NOTE function not implemented, YOU get to do it!');
			END;
	END;


	PROCEDURE DealwthDialogs (Event : EventRecord);
		VAR
			ItemHit : Integer;
			thedialog : DialogPtr;
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;
			mess, err : integer;
			orn : longint;
			key : str255;

		PROCEDURE DoINQ;
			LABEL
				999;

			PROCEDURE GetNewEditFields;
			BEGIN
				GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, EditRec.person);
				GetDItem(INQptr, 4, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, EditRec.company);
				GetDItem(INQptr, 6, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, EditRec.addr);
				GetDItem(INQptr, 8, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, EditRec.citystate);
				GetDItem(INQptr, 10, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, EditRec.phone);
			END;	{of GetNewEditFields}

			PROCEDURE SetNewEditFields;
			BEGIN
				GetRec;
				ToEditRec;
				GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.person);
				GetDItem(INQptr, 4, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.company);
				GetDItem(INQptr, 6, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.addr);
				GetDItem(INQptr, 8, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.citystate);
				GetDItem(INQptr, 10, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.phone);
			END;	{of SetNewEditFields}

			FUNCTION Selkey (et : integer) : integer;
			BEGIN
				GetDItem(INQptr, et * 2, ItemType, ItemHandle, ItemBox);
				GetIText(ItemHandle, key);
				IF et = 1 THEN
					BEGIN
						GetDItem(INQptr, 4, ItemType, ItemHandle, ItemBox);
						GetIText(ItemHandle, findit);
						key := concat(key, StringALL(' ', 40));
						key[0] := chr(40);
						key := concat(key, findit);
					END;
				IF et = 2 THEN
					BEGIN
						GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
						GetIText(ItemHandle, findit);
						key := concat(key, StringALL(' ', 40));
						key[0] := chr(40);
						key := concat(key, findit);
					END;
				errcode := ISAMkey(drefnum, et, FWD);
				errcode := ISAMfind(drefnum, key, foundit, recno);
				errcode := ISAMnext(drefnum, recno, foundit);
				GetRec;
				SetNewEditFields;
				GetDItem(INQptr, (kn * 2) + 1, ItemType, ItemHandle, ItemBox);
				SetCtlValue(ControlHandle(ItemHandle), 0);
				kn := et;
				SelIText(INQptr, (kn * 2), 0, 999);
				GetDItem(INQptr, (kn * 2) + 1, ItemType, ItemHandle, ItemBox);
				SetCtlValue(ControlHandle(ItemHandle), 1);
				Selkey := et;
			END;	{of Selkey}

		BEGIN
			mess := 0;
			IF (Event.what = keyDown) OR (Event.what = autoKey) THEN
				BEGIN
					mess := Event.message MOD 256;
					IF BitAnd(Event.modifiers, CmdKey) = Cmdkey THEN
						BEGIN
							IF (mess > 64) AND (mess < 91) THEN
								mess := mess - 64;
							IF (mess > 96) AND (mess < 123) THEN
								mess := mess - 96;
						END;
					IF mess = 2 THEN
						DlgDelete(INQptr);
					IF mess = 3 THEN
						dlgCopy(INQptr);
					IF mess = 9 THEN
						mess := 13;
					IF mess = 13 THEN
						BEGIN
							en := (en MOD 5) + 1;
							SelIText(INQptr, (en * 2), 0, 999);
						END;
					IF mess = 17 THEN
						BEGIN
							closefile;
						END;
					IF mess = 22 THEN
						dlgPaste(INQptr);
					IF mess = 24 THEN
						dlgCut(INQptr);
					IF mess = 26 THEN
						BEGIN
							SetNewEditFields;
							SelIText(INQptr, (kn * 2), 0, 999);
							en := kn;
						END;
				END;
			IF (mess = 0) OR (mess > 31) OR (mess = 8) THEN
				IF DialogSelect(Event, thedialog, ItemHit) THEN
					IF Event.what = mouseDown THEN
						CASE ItemHit OF
							1 : 
								BEGIN
								END;
							2 : 
								en := 1;
							3 : 
								en := Selkey(1);		{person name}
							4 : 
								en := 2;
							5 : 
								en := Selkey(2);		{company name}
							6 : 
								en := 3;
							7 : 
								en := Selkey(3);		{addr}
							8 : 
								en := 4;
							9 : 
								en := Selkey(4);		{city-state}
							10 : 
								en := 5;
							11 : 
								en := Selkey(5);		{phone}
							12 : 
								BEGIN								{UP button}
									errcode := ISAMprevious(drefnum, recno, foundit);
									SetNewEditFields;
									SelIText(INQptr, (kn * 2), 0, 999);
									en := kn;
								END;
							13 : 
								BEGIN								{DOWN button}
									errcode := ISAMnext(drefnum, recno, foundit);
									SetNewEditFields;
									SelIText(INQptr, (kn * 2), 0, 999);
									en := kn;
								END;
							14 : 
								BEGIN								{Note button}
									GetNewEditFields;
									DoNote;
								END;
							15 : 
								BEGIN								{Dial button}
									GetNewEditFields;
									DoDial;
								END;
							16 : 
								BEGIN								{Label button}
									GetNewEditFields;
									DoLabel;
								END;
							17 : 
								BEGIN								{QUIT button}
									closefile;
								END;
							18 : 
								BEGIN								{New button}
									GetNewEditFields;
									INQshow := FALSE;
									SetUpADD;
									HideWindow(INQptr);
									FlushEvents(everyEvent, 0);
								END;
							19 : 
								BEGIN								{Update button}
									IF recno >= 0 THEN
										BEGIN
											GetNewEditFields;
											ToDataRec;
											PutRec;
											errcode := ISAMupdate(drefnum, @DataRec, recno);
											IF errcode <> isamOK THEN
												BEGIN
													ISAMerror(etext);
													msg(etext);
												END;
											orn := recno;
											GetDItem(INQptr, kn * 2, ItemType, ItemHandle, ItemBox);
											GetIText(ItemHandle, key);
											IF kn = 1 THEN
												BEGIN
													GetDItem(INQptr, 4, ItemType, ItemHandle, ItemBox);
													GetIText(ItemHandle, findit);
													key := concat(key, StringALL(' ', 40));
													key[0] := chr(40);
													key := concat(key, findit);
												END;
											IF kn = 2 THEN
												BEGIN
													GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
													GetIText(ItemHandle, findit);
													key := concat(key, StringALL(' ', 40));
													key[0] := chr(40);
													key := concat(key, findit);
												END;
											errcode := ISAMkey(drefnum, kn, FWD);
											errcode := ISAMfind(drefnum, key, foundit, recno);
											REPEAT
												errcode := ISAMnext(drefnum, recno, foundit);
											UNTIL ((errcode <> isamOK) OR (recno = orn));
											SetNewEditFields;
											SelIText(INQptr, (en * 2), 0, 999);
										END;
								END;
							20 : 
								BEGIN								{Delete button}
									IF recno >= 0 THEN
										BEGIN
											errcode := ISAMdelete(drefnum, recno);
											IF errcode <> isamOK THEN
												BEGIN
													ISAMerror(etext);
													msg(etext);
												END;
											EditRec.person := '[[[[[ DELETED ]]]]]';
											ToDataRec;
											PutRec;
											GetDItem(INQptr, kn * 2, ItemType, ItemHandle, ItemBox);
											GetIText(ItemHandle, key);
											IF kn = 1 THEN
												BEGIN
													GetDItem(INQptr, 4, ItemType, ItemHandle, ItemBox);
													GetIText(ItemHandle, findit);
													key := concat(key, StringALL(' ', 40));
													key[0] := chr(40);
													key := concat(key, findit);
												END;
											IF kn = 2 THEN
												BEGIN
													GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
													GetIText(ItemHandle, findit);
													key := concat(key, StringALL(' ', 40));
													key[0] := chr(40);
													key := concat(key, findit);
												END;
											errcode := ISAMkey(drefnum, kn, FWD);
											errcode := ISAMfind(drefnum, key, foundit, recno);
											errcode := ISAMnext(drefnum, recno, foundit);
											SetNewEditFields;
											SelIText(INQptr, (en * 2), 0, 999);
										END;
								END;
							21 : 
								BEGIN								{Revert button}
									SetNewEditFields;
									SelIText(INQptr, (kn * 2), 0, 999);
									en := kn;
								END;
							OTHERWISE
						END;
			IF SW[0] <> 0 THEN
				BEGIN
					IF SW[1] <> 0 THEN
						SayIt(EditRec.person);
					IF SW[2] <> 0 THEN
						SayIt(EditRec.company);
					IF SW[3] <> 0 THEN
						SayIt(EditRec.addr);
					IF SW[4] <> 0 THEN
						SayIt(EditRec.citystate);
					IF SW[5] <> 0 THEN
						SayIt(EditRec.phone);
				END;
999 :
		END; {of DoINQ}

		PROCEDURE DoADD;
			LABEL
				999;

			PROCEDURE SetNewEditFields;
			BEGIN
				GetRec;
				ToEditRec;
				GetDItem(ADDptr, 2, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.person);
				GetDItem(ADDptr, 3, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.company);
				GetDItem(ADDptr, 4, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.addr);
				GetDItem(ADDptr, 5, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.citystate);
				GetDItem(ADDptr, 6, ItemType, ItemHandle, ItemBox);
				SetIText(ItemHandle, EditRec.phone);
			END;	{of SetNewEditFields}

		BEGIN
			mess := 0;
			IF (Event.what = keyDown) OR (Event.what = autoKey) THEN
				BEGIN
					mess := Event.message MOD 256;
					IF BitAnd(Event.modifiers, CmdKey) = Cmdkey THEN
						BEGIN
							IF (mess > 64) AND (mess < 91) THEN
								mess := mess - 64;
							IF (mess > 96) AND (mess < 123) THEN
								mess := mess - 96;
						END;
					IF mess = 2 THEN
						DlgDelete(ADDptr);
					IF mess = 3 THEN
						dlgCopy(ADDptr);
					IF mess = 9 THEN
						mess := 13;
					IF mess = 13 THEN
						BEGIN
							en := (en MOD 5) + 1;
							SelIText(ADDptr, (en + 1), 0, 999);
						END;
					IF mess = 22 THEN
						dlgPaste(ADDptr);
					IF mess = 24 THEN
						dlgCut(ADDptr);
					IF mess = 26 THEN
						BEGIN
							SetNewEditFields;
							SelIText(ADDptr, (kn + 1), 0, 999);
							en := kn;
						END;
				END;
			IF (mess = 0) OR (mess > 31) OR (mess = 8) THEN
				IF DialogSelect(Event, thedialog, ItemHit) THEN
					IF Event.what = mouseDown THEN
						CASE ItemHit OF
							1 : 
								BEGIN
								END;
							2 : 
								en := 1;
							3 : 
								en := 2;
							4 : 
								en := 3;
							5 : 
								en := 4;
							6 : 
								en := 5;
							7 : 
								BEGIN								{Clear button}
									GetDItem(ADDptr, 2, ItemType, ItemHandle, ItemBox);
									SetIText(ItemHandle, '');
									GetDItem(ADDptr, 3, ItemType, ItemHandle, ItemBox);
									SetIText(ItemHandle, '');
									GetDItem(ADDptr, 4, ItemType, ItemHandle, ItemBox);
									SetIText(ItemHandle, '');
									GetDItem(ADDptr, 5, ItemType, ItemHandle, ItemBox);
									SetIText(ItemHandle, '');
									GetDItem(ADDptr, 6, ItemType, ItemHandle, ItemBox);
									SetIText(ItemHandle, '');
									SelIText(ADDptr, (kn + 1), 0, 999);
									en := kn;
								END;
							8 : 
								BEGIN								{Add button}
									GetDItem(ADDptr, 2, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, EditRec.person);
									GetDItem(ADDptr, 3, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, EditRec.company);
									GetDItem(ADDptr, 4, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, EditRec.addr);
									GetDItem(ADDptr, 5, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, EditRec.citystate);
									GetDItem(ADDptr, 6, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, EditRec.phone);
									ToDataRec;
									errcode := ISAMadd(drefnum, @DataRec, recno);
									IF errcode <> isamOK THEN
										BEGIN
											ISAMerror(etext);
											msg(etext);
										END;
									maxnumlink := maxnumlink + 1;
									DataRec.NumLink := maxnumlink;
									DataRec.Kind := 1;
									PutRec;
									orn := recno;
									GetDItem(ADDptr, kn + 1, ItemType, ItemHandle, ItemBox);
									GetIText(ItemHandle, key);
									IF kn = 1 THEN
										BEGIN
											GetDItem(ADDptr, 3, ItemType, ItemHandle, ItemBox);
											GetIText(ItemHandle, findit);
											key := concat(key, StringALL(' ', 40));
											key[0] := chr(40);
											key := concat(key, findit);
										END;
									IF kn = 2 THEN
										BEGIN
											GetDItem(ADDptr, 2, ItemType, ItemHandle, ItemBox);
											GetIText(ItemHandle, findit);
											key := concat(key, StringALL(' ', 40));
											key[0] := chr(40);
											key := concat(key, findit);
										END;
									errcode := ISAMkey(drefnum, kn, FWD);
									errcode := ISAMfind(drefnum, key, foundit, recno);
									REPEAT
										errcode := ISAMnext(drefnum, recno, foundit);
									UNTIL ((errcode <> isamOK) OR (recno = orn));
									GetRec;
									ADDshow := FALSE;
									SetUpINQ;
									HideWindow(ADDptr);
									FlushEvents(everyEvent, 0);
									SW[0] := 0;
								END;
							9 : 
								BEGIN								{No Add button}
									ADDshow := FALSE;
									SetUpINQ;
									HideWindow(ADDptr);
									FlushEvents(everyEvent, 0);
									SW[0] := 0;
								END;
							10 : 
								BEGIN								{Revert button}
									SetNewEditFields;
									SelIText(ADDptr, (kn + 1), 0, 999);
									en := kn;
								END;
							OTHERWISE
						END;
999 :
		END; {of DoADD}

	BEGIN
		IF INQshow THEN
			BEGIN
				SetPort(INQptr);
				DoINQ;
			END
		ELSE IF ADDshow THEN
			BEGIN
				SetPort(ADDptr);
				DoADD;
			END;
	END; {of DealwthDialogs}


	PROCEDURE DealwthMouseDowns (Event : EventRecord);
		VAR
			Location : integer;
			WindowPointedTo : WindowPtr;
			MouseLoc : Point;
			WindoLoc : integer;
	BEGIN
		MouseLoc := Event.Where;
		WindoLoc := FindWindow(MouseLoc, WindowPointedTo);
		CASE WindoLoc OF
			inMenuBar : 
				ProcessMenu_in(MenuSelect(MouseLoc));
			inSysWindow : 
				SystemClick(Event, WindowPointedTo);
			inContent : 
				BEGIN
				END;
			inGrow : 
				BEGIN
				END;
			inDrag : 
				BEGIN
				END;
			inGoAway : 
				BEGIN
				END;
			OTHERWISE
		END;{ of case}
	END;


	PROCEDURE DealwthKeyDowns (Event : EventRecord);
		TYPE
			Trick = PACKED RECORD
					CASE boolean OF
						true : (
								l : longint
						);
						false : (
								chr3, chr2, chr1, chr0 : char
						)
				END;
		VAR
			CharCode : char;
			TrickVar : Trick;
	BEGIN
		TrickVar.l := Event.message;
		CharCode := TrickVar.chr0;
		IF BitAnd(Event.modifiers, CmdKey) = CmdKey THEN
			BEGIN
				ProcessMenu_in(MenuKey(CharCode));
			END
		ELSE
			BEGIN
			END;
	END;


	PROCEDURE DealwthActivates (Event : EventRecord);
		VAR
			TargetWindow : WindowPtr;
	BEGIN
		TargetWindow := WindowPtr(Event.message);
		DrawGrowIcon(TargetWindow);
		IF Odd(Event.modifiers) THEN
			BEGIN
				SetPort(TargetWindow);
			END
		ELSE
			BEGIN
			END;
	END;


	PROCEDURE DealwthUpdates (Event : EventRecord);
		VAR
			UpDateWindow, TempPort : WindowPtr;
	BEGIN
		UpDateWindow := WindowPtr(Event.message);
		GetPort(TempPort);
		SetPort(UpDateWindow);
		BeginUpDate(UpDateWindow);
		EraseRect(UpDateWindow^.VisRgn^^.rgnBBox);
		DrawGrowIcon(UpDateWindow);
		EndUpDate(UpDateWindow);
		SetPort(TempPort);
	END;


	PROCEDURE SetUpThings;
		VAR
			ItemType : Integer;
			ItemHandle : Handle;
			ItemBox : Rect;
			MenuTopic : MenuHandle;
			i : integer;
			err : oserr;
	BEGIN
	{create a grafport for the screen}
		InitGraf(@thePort);

	{extra pointer blocks}
		MoreMasters;
		MoreMasters;
		MoreMasters;
		MoreMasters;

	{get the watch and set it}
		TheIBeam := GetCursor(iBeamCursor);
		TheWatch := GetCursor(watchCursor);
		SetCursor(TheWatch^^);

	{init everything in case this is Startup App}
		InitFonts;
		InitWindows;
		InitMenus;
		TEInit;
		InitDialogs(NIL);

	{get modeless dialogs}
		SetDAFont(1);
		INQptr := GetNewDialog(INQDLG, NIL, Pointer(-1));
		ADDptr := GetNewDialog(ADDDLG, NIL, Pointer(-1));
		SetDAFont(0);

	{get edit rect for modeless dialogs}
		GetDItem(INQptr, 2, ItemType, ItemHandle, ItemBox);
		SWCrect.topLeft := ItemBox.topLeft;
		GetDItem(INQptr, 10, ItemType, ItemHandle, ItemBox);
		SWCrect.botRight := ItemBox.botRight;

	{setup menus}
		MenuTopic := GetMenu(AppleMenu);
		AddResMenu(MenuTopic, 'DRVR');
		InsertMenu(MenuTopic, 0);
		MenuTopic := GetMenu(FileMenu);
		InsertMenu(MenuTopic, 0);
		FMhandle := MenuTopic;
		MenuTopic := GetMenu(EditMenu);
		InsertMenu(MenuTopic, 0);
		MenuTopic := GetMenu(SpeakMenu);
		InsertMenu(MenuTopic, 0);
		SMhandle := MenuTopic;
		DrawMenuBar;

	{setup modem port for DIAL function}
		mset := TRUE;

	{setup printer port for LABEL function (IMAGEWRITER)}
		pset := TRUE;

	{startup ISAM}
		errcode := ISAMinitialize('');
		IF errcode <> isamOK THEN
			BEGIN
				msg('FATAL ISAMinitialize failure');
				ExitToShell;
			END;
		ISAMversion(vtext);

  {Open the speech driver}
		FOR i := 0 TO 5 DO
			SW[i] := 0;
		SErr := SpeechOn('', theSpeech);
		IF SErr <> noErr THEN
			BEGIN
				DisableItem(SMhandle, 0);
				DrawMenuBar;
			END
		ELSE
			BEGIN
				SpeechRate(theSpeech, 200);
			END;

	{final stuff}
		Finished := FALSE;
		FileIsOpen := FALSE;
		INQshow := FALSE;
		ADDshow := FALSE;
		fname := '';
		SetCursor(arrow);
		FlushEvents(everyEvent, 0);
	END;


	PROCEDURE CloseThings;
	BEGIN
		closefile;
		ISAMterminate;
		IF SErr = 0 THEN
			SpeechOff(theSpeech);
	END;


	PROCEDURE MainEventLoop;
		VAR
			Event : EventRecord;
			ProcessIt : Boolean;
			thedialog : DialogPtr;
			WL : ^longint;
			mouseloc : point;
			dummy : integer;
	BEGIN
		REPEAT
			SystemTask;
			ProcessIt := GetNextEvent(EveryEvent, Event);
			IF (IsDialogEvent(Event)) AND (INQshow OR ADDshow) THEN
				DealwthDialogs(Event)
			ELSE IF ProcessIt THEN
				CASE Event.what OF
					mouseDown : 
						DealwthMouseDowns(Event);
					KeyDown : 
						DealwthKeyDowns(Event);
					ActivateEvt : 
						DealwthActivates(Event);
					UpDateEvt : 
						DealwthUpdates(Event);
					OTHERWISE
				END;
			IF INQshow OR ADDshow THEN
				BEGIN
					GetMouse(mouseloc);
					LocalToGlobal(mouseloc);
					dummy := FindWindow(mouseloc, thedialog);
					GlobalToLocal(mouseloc);
					WL := pointer(2518);				{'windowList'}
					WL := pointer(ord4(WL^));		{now pointer to top window}
					IF ord4(WL) = ord4(thedialog) THEN
						IF (thedialog = INQptr) OR (thedialog = ADDptr) THEN
							IF PtinRect(mouseloc, SWCRect) THEN
								SetCursor(TheIBeam^^)
							ELSE
								SetCursor(arrow);
				END;
		UNTIL Finished;
	END;


BEGIN
	SetUpThings;
	AboutNaD;
	MainEventLoop;
	CloseThings;
END.